#-----------------------------
#
#  Sitestat-X (Rev 5a) by GOD-EMPEROR (2002)
#
#  (This is not a standalone script, it requires a linked ss-main bot)
#
#-----------------------------
#
#  Install this on any bot linked to any other running Sitestat 4.5
#  and it will allow you to echo all the announces to any other IRC
#  network or channel. Note that since it uses Sitestat's partyline
#  announcing, it will need a valid login on the ftp, it needs no
#  special user flags, nor will it have to actually login to the ftp
#  all it will do is echo what it sees; so the echo-bot can be used
#  to lessen the burden on the main bot which if on the same channel
#  can be used for commands instead, freeing up ss-main to announce.
#
#-----------------------------
#
# listen for commands here, and announce to these channels
#  (if invite is enabled for this bot invite will be to the first channel defined here)
set ZCHANS "#chan1 #chan2 #chan3"
#-----------------------------
#
# Sitestat bot's handle (the one loading ss5-main.tcl)
set SSBOT "BanDiDo"
#-----------------------------
#
# command prefix, if you want this bot to announce only, comment out the bind lines
set SBPFX "!site"
#
# /MSG invite trigger, set this to something long and funky to disable
set IPFX "!invite"
#
#
################################## begin code.

bind bot - ss5pub ahandler
proc ahandler {h i o} {
  global ZCHANS
  foreach chan $ZCHANS {putserv "PRIVMSG $chan :[lindex $o 0]"}
}
bind bot - ss5msg bhandler
proc bhandler {h i o} {
  putserv "PRIVMSG [lindex $o 0] :[lindex $o 1]"
}

bind bot - ss5inv ihandler
proc ihandler {hand idx args} {
  global SSBOT
  set args [lindex $args 0]
  foreach {nick user group chan str} $args {}
  if ![botisop $chan] {putserv "PRIVMSG $chan :Would it be too much trouble to op me so I could invite some lewser? ..." ; return}
  putbot $SSBOT "ss5log sitestat-x: invited user - [list $nick] ($chan)"
  putserv "PRIVMSG $chan :$str"
  if ![onchan $nick $chan] {putserv "INVITE $nick $chan"}
}

bind bot - ssxinv xhandler
proc xhandler {hand idx args} {
  global ZCHANS SSBOT
  set args [lindex $args 0]
  foreach {user nick uhost} $args {}
  set chan [lindex $ZCHANS 0]
  if ![botisop $chan] {putserv "PRIVMSG $chan :Would it be too much trouble to op me so I could invite some lewser? ..." ; return}
  if ![string match $uhost [gethost $nick]] {putbot $SSBOT "ss5log sitestat-x: WARNING : invite aborted - userhost mismatch" ; return}
  putbot $SSBOT "ss5log sitestat-x: invited user - [list $nick] ($chan)"
  putserv "PRIVMSG $chan :\002\[\002 Sitestat-X Invited: \002[list $nick]\002 (from $uhost) \002\]"
  if ![onchan $nick $chan] {putserv "INVITE $nick $chan"}
}

proc achks {c args} {
  if {$args == ""} {putserv "PRIVMSG $c :this command requires some arguments..." ; return -code return}
}
bind msg - $IPFX invorate
bind pub - [set SBPFX]bw allcmdhandler
bind pub - [set SBPFX]speed allcmdhandler
bind pub - [set SBPFX]free allcmdhandler
bind pub - [set SBPFX]user allcmdhandler
bind pub - [set SBPFX]stat allcmdhandler
bind pub - [set SBPFX]dir allcmdhandler
bind pub - [set SBPFX]last allcmdhandler
bind pub - [set SBPFX]search allcmdhandler
bind pub - [set SBPFX]build allcmdhandler
bind pub - [set SBPFX]ver allcmdhandler
bind pub - [set SBPFX]help allcmdhandler
bind pub - [set SBPFX]help2 allcmdhandler
bind pub - [set SBPFX]rules allcmdhandler
bind pub - [set SBPFX]who allcmdhandler
bind pub - [set SBPFX]idlers allcmdhandler
bind pub - [set SBPFX]leechers allcmdhandler
bind pub - [set SBPFX]uploaders allcmdhandler
bind pub - [set SBPFX]idlers allcmdhandler
set botnack [set botnet-nick]
set ZCHANS [string tolower $ZCHANS]
set SBPFX [string tolower $SBPFX]

proc invorate {nick uhost hand args} {
  global SSBOT
  set args [lindex $args 0]
  set user [lindex $args 0]
  set pass [lindex $args 1]
  putbot $SSBOT "echoinv \{$user\} \{$pass\} \{$nick\} \{$uhost\}"
}

proc allcmdhandler {n u h c args} {
  global ZCHANS lastbind SBPFX SSBOT botnack
  set c [string tolower $c]
  if {[lsearch $ZCHANS $c] == -1} {putbot $SSBOT "ss5log sitestat-x: NOTICE : ignored user command - undefined channel ($c)" ; return}
  set args [string trim $args]
  set largs [string tolower $args]
  set cmd [string map "$SBPFX {}" [string tolower $lastbind]]
  putserv "PRIVMSG $c :command received, hang on..."
  switch -- $cmd {
	speed {achks $c $args ; putbot $SSBOT "echocmd speedalias \{$n\} $u \{\} \{$c\} $args"}
	free {achks $c $args ; putbot $SSBOT "echocmd freealias \{$n\} $u \{\} \{$c\} \{$largs\}"}
	user {achks $c $args ; putbot $SSBOT "echocmd useralias \{$n\} $u \{\} \{$c\} $args"}
	stat {achks $c $args ; putbot $SSBOT "echocmd sitestat \{$n\} $u \{\} \{$c\} \{$largs\}"}
	dir {achks $c $args ; putbot $SSBOT "echocmd sitedir \{$n\} $u \{\} \{$c\} \{$args\}"}
	last {achks $c $args ; putbot $SSBOT "echocmd sitelast \{$n\} $u \{\} \{$c\} \{$largs\}"}
	search {achks $c $args ; putbot $SSBOT "echocmd sitesearch \{$n\} $u \{\} \{$c\} \{$args\}"}
	trials {achks $c $args ; putbot $SSBOT "echocmd showtr \{$n\} $u \{\} \{$c\} \{$args\}"}
  }
  switch -- $cmd {
	build {
		putbot $SSBOT "echocmd sitever2 \{$n\} $u \{\} \{$c\} \{\}"
		putserv "PRIVMSG $c :\002Sitestat-X 0.7 \002(Echo bot) for \002Sitestat 4.5"
	}
	ver {
		putbot $SSBOT "echocmd sitever \{$n\} $u \{\} \{$c\} \{\}"
		putserv "PRIVMSG $c :\002Sitestat-X \002(Echo bot) for \002Sitestat 4.5"
	}
	bnc {putbot $SSBOT "echocmd showbnc \{$n\} $u \{\} \{$c\} \{\}"}
	help {putbot $SSBOT "echocmd userhelp \{$n\} $u \{\} \{$c\} \{\}"}
	help2 {putbot $SSBOT "echocmd morehelp \{$n\} $u \{\} \{$c\} \{\}"}
	rules {putbot $SSBOT "echocmd rulesalias \{$n\} $u \{\} \{$c\} \{\}"}
	who {putbot $SSBOT "echocmd whoalias \{$n\} $u \{\} \{$c\} \{\}"}
	bw {putbot $SSBOT "echocmd bwalias \{$n\} $u \{\} \{$c\} \{\}"}
	idlers {putbot $SSBOT "echocmd idlealias \{$n\} $u \{\} \{$c\} \{\}"}
	leechers {putbot $SSBOT "echocmd leechalias \{$n\} $u \{\} \{$c\} \{\}"}
	uploaders {putbot $SSBOT "echocmd upalias \{$n\} $u \{\} \{$c\} \{\}"}

  }
}


putlog "Sitestat-X loaded."